--this is where the main gaming screen is setup. rearrange the buttons, etc.. to your liking.

MainScreen = Core.class(Sprite)

function MainScreen:init()
	--these variables are for the buttons that respond to user input
	self.north = {}
	self.south = {}
	self.west = {}
	self.east = {}

	--set up the application variables
	application:setLogicalDimensions(1200, 1920)
	application:setOrientation(Application.LANDSCAPE_LEFT)
	application:setScaleMode("letterbox")
	application:setBackgroundColor(constants.BG_COLOR)

	--[[load a background image
	local bg = Bitmap.new(Texture.new("images/background.png", true))
	bg:setAnchorPoint(0.5, 0.5)
	bg:setPosition(constants.appwidth/2, constants.appheight/2)
	print(constants.appwidth/2, constants.appheight/2)
	self:addChild(bg)
	--]]

	--this covers the map on the right side of the screen
	local fg = Bitmap.new(Texture.new("images/foreground.png", true))
	fg:setX(constants.FG_X)
	self:addChild(fg)

	--this covers 6px on the bottom of the screen
	local fg2 = Shape.new() 
	fg2:beginPath()         
	fg2:setLineStyle(1)     
	fg2:setFillStyle(Shape.SOLID, constants.BG_COLOR) 			-- solid fill color
	fg2:moveTo(0,0)     										-- move pen to start of line
	fg2:lineTo(constants.SCREEN_TILES * constants.TILE_WIDTH, 0)  -- draw top of rectangle
	fg2:lineTo(constants.SCREEN_TILES * constants.TILE_WIDTH,6)   -- draw right side of rectangle
	fg2:lineTo(0,6)    											-- draw bottom of rectangle
	fg2:lineTo(0,0)     										-- draw left side of rectangle
	fg2:endPath()           									-- end the path
	fg2:setPosition(constants.OFFSET_X, constants.OFFSET_Y + constants.SCREEN_TILES * constants.TILE_HEIGHT)
	self:addChild(fg2)
	
	--this covers area behind the buttons on the left of the screen
	local fg3 = Shape.new() 
	fg3:beginPath()         
	fg3:setLineStyle(1)     
	fg3:setFillStyle(Shape.SOLID, constants.bgColor) 									-- solid fill color
	fg3:moveTo(0,0)     																-- move pen to start of line
	fg3:lineTo(constants.OFFSET_X + constants.DX, 0)  									-- draw top of rectangle
	fg3:lineTo(constants.OFFSET_X + constants.DX, constants.APP_HEIGHT + constants.DY)	-- draw right side of rectangle
	fg3:lineTo(0,constants.APP_HEIGHT + constants.DY)    								-- draw bottom of rectangle
	fg3:lineTo(0,0)     																-- draw left side of rectangle
	fg3:endPath()           															-- end the path
	fg3:setPosition(-constants.DX, -constants.DY)
	self:addChild(fg3)

	--load a foreground image 
	local compass = Bitmap.new(Texture.new("images/compass.png", true, {transparentColor = 0xff00ff}))
	compass:setPosition(1570, 785)
	self:addChild(compass)
	
	--set up the buttons
	local directionup = TextField.new(constants.FONT_XL, " N ", true)
	local directiondown = TextField.new(constants.FONT_XL, " N ", true)
	directionup:setTextColor(constants.FONTCOLOR_WHITE)	
	directiondown:setTextColor(constants.FONTCOLOR_BLUE)
	self.north = Button.new(directionup, directiondown)
	self.north:setPosition(1580, 800)  
	self:addChild(self.north)
	
	local directionup = TextField.new(constants.FONT_XL, " S ", true)
	local directiondown = TextField.new(constants.FONT_XL, " S ", true)
	directionup:setTextColor(constants.FONTCOLOR_WHITE)	
	directiondown:setTextColor(constants.FONTCOLOR_BLUE)
	self.south = Button.new(directionup, directiondown)
	self.south:setPosition(1584, 1120)  
	self:addChild(self.south)
	
	local directionup = TextField.new(constants.FONT_XL, " W ", true)
	local directiondown = TextField.new(constants.FONT_XL, " W ", true)
	directionup:setTextColor(constants.FONTCOLOR_WHITE)	
	directiondown:setTextColor(constants.FONTCOLOR_BLUE)
	self.west = Button.new(directionup, directiondown)
	self.west:setPosition(1372, 950)  
	self:addChild(self.west)
	
	local directionup = TextField.new(constants.FONT_XL, " E ", true)
	local directiondown = TextField.new(constants.FONT_XL, " E ", true)
	directionup:setTextColor(constants.FONTCOLOR_WHITE)	
	directiondown:setTextColor(constants.FONTCOLOR_BLUE)
	self.east = Button.new(directionup, directiondown)
	self.east:setPosition(1740, 950)  
	self:addChild(self.east)

	self.magicup = Bitmap.new(Texture.new("images/button-magic-144px.png", true))
	self.magicdown = Bitmap.new(Texture.new("images/button-magic-selected-144px.png", true))
	self.magic = Button.new(self.magicup, self.magicdown)
	self.magic:setPosition(0, constants.OFFSET_Y + constants.TILE_HEIGHT * 4)
	self:addChild(self.magic)

	self.rangedup = Bitmap.new(Texture.new("images/button-ranged-144px.png", true))
	self.rangeddown = Bitmap.new(Texture.new("images/button-ranged-selected-144px.png", true))
	self.ranged = Button.new(self.rangedup, self.rangeddown)
	self.ranged:setPosition(0, constants.OFFSET_Y + constants.TILE_HEIGHT * 5.5)
	self:addChild(self.ranged)

	self.meleeup = Bitmap.new(Texture.new("images/button-melee-144px.png", true))
	self.meleedown = Bitmap.new(Texture.new("images/button-melee-selected-144px.png", true))
	self.melee = Button.new(self.meleeup, self.meleedown)
	self.melee:setPosition(0, constants.OFFSET_Y + constants.TILE_HEIGHT * 7)
	self:addChild(self.melee)

	--exit properly if user hits the back button
	self:addEventListener(Event.KEY_DOWN, function(event)
		if event.keyCode == KeyCode.BACK then
			if application:getDeviceInfo() == "Android" then
				application:exit()
			end
		end
	end)
	
end