Monster = Core.class()

function Monster:init(entry, info)
	--these are all the monster variables
	self.entry = entry							--position in the MonsterList and tileset-monsters.png
	self.hp = math.random(1, info.hp)
	self.weapon = info.weapon
	self.ac = info.ac 
	self.x = math.random(2, constants.MAP_ROWS - 1)
	self.y = math.random(2, constants.MAP_COLUMNS - 1)
	self.onscreen = false
end

Monsters = Core.class(Sprite)
 
function Monsters:init()
	--create a table for all the layer keys and a Sprite group to easily manipulate
    self.tList = {}
	self.tMM = loadfile("classes/MonsterList.lua")()
end

function Monsters:place(arrays, entry)
--[[uses the worldarrays to check for monsters on the map before placing a monster from
	the entry in the monster manual
	adds a monster of the Monster class to self.tList
--]]
	local function generate()
		--[[check that there is no monster on that location map first --]]
		local array = arrays[constants.LAYER_MONSTERS]
		local m = nil
		repeat
			m = Monster.new(entry, self.tMM[entry])
			-- i is x & y turned into the index in the maparray table 
			local i = m.x + (m.y - 1) * constants.MAP_COLUMNS	
			placed = array[i] == 0 	--returns false is there is a monster already there
		until placed 
		return m
	end
	table.insert(self.tList, generate())
end