--this file creates a tilemap class and a WorldMap class all the functions associated with adding to and substacting from them

Tiles = Core.class(Sprite)

local function mapindex(x, y)
--returns the index of for the map array
	return x + (y - 1) * constants.MAP_COLUMNS
end

local function tileid(tileset, x, y) 
--returns the local tile id at a given tile location in a tileset
	return x + (y - 1) * (tileset.imagewidth / tileset.tilewidth)
end

function Tiles:init(tMaparray, tTileset)
	--return a TileMap for a given tileset			
	local t = Texture.new(tTileset, true, {transparentColor = 0xff00ff})
	local tilemap = TileMap.new(constants.MAP_COLUMNS, constants.MAP_ROWS, t, constants.TILE_WIDTH, constants.TILE_HEIGHT)
	
	--these for loops assign each tile in the TileMap 
	for y = 1, constants.MAP_ROWS do
		for x = 1, constants.MAP_COLUMNS do
			local i = x + (y - 1) * constants.MAP_COLUMNS
			local tx = tMaparray[i]
			local ty = 1
			tilemap:setTile(x, y, tx, ty)
		end
	end
	self:addChild(tilemap)
end

WorldMap = Core.class(Sprite)
 
function WorldMap:init()
	--create a table for all the layer keys and a Sprite group to easily manipulate
    self.tWorldmap = {}
	self.sAlllayers = Sprite.new()
	
	self.tWorldmap = loadfile("classes/TileSets.lua")()
	self.tMonstermanual = loadfile("classes/MonsterList.lua")()
	self.tBGinfo = loadfile("classes/BackgroundList.lua")()
	
	local t = Tiles.new(self.tWorldmap[constants.LAYER_BG], "images/tileset-background-108px.png")
	self.sAlllayers:addChildAt(t, constants.LAYER_BG) 
	local t = Tiles.new(self.tWorldmap[constants.LAYER_MONSTERS], "images/tileset-monsters-108px.png")
	self.sAlllayers:addChildAt(t, constants.LAYER_MONSTERS)
	self.sAlllayers:setPosition(constants.OFFSET_X, constants.OFFSET_Y)

	self:addChild(self.sAlllayers)
end

function WorldMap:changeTile(layer, entry, x, y)
--this function changes the self.tWorldmap array entry and the tile in self.sWorldlayers
	print(layer, entry, x, y)
	l = self.tWorldmap[layer]
	l[mapindex(x, y)] = entry
	local s = self.sAlllayers:getChildAt(layer)
	print(s)
	s:setTile(x, y, entry, 1)
end

